import * as mc from '@minecraft/server';

const coals = [
    "minecraft:redstone/5",
    "minecraft:redstone_block/45"
]

const itemsUsed = [
    "minecraft:sand/minecraft:glass",
    "minecraft:cobblestone/minecraft:stone",
    "minecraft:cactus/minecraft:green_dye",
    "minecraft:kelp/minecraft:dried_kelp",
    "minecraft:porkchop/minecraft:cooked_porkchop",
    "minecraft:beef/minecraft:cooked_beef",
    "minecraft:mutton/minecraft:cooked_mutton",
    "minecraft:cod/minecraft:cooked_cod",
    "minecraft:salmon/minecraft:cooked_salmon",
    "minecraft:chicken/minecraft:cooked_chicken",
    
  
    
]

function getCoalItem(inv) {
    for (let i = 0; i < inv.size; i++) {
        const item = inv.getItem(i)
        if (item) {
            for (let v of coals) {
                const itemM = v.split("/")[0]
                const fuel = v.split("/")[1]
                if (itemM === item.typeId) return {
                    item: item.typeId,
                    fuel: Number(fuel),
                    remove(player) {
                        mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback false`)
                        player.runCommandAsync(`clear @s ${item.typeId} 0 1`)
                        mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback true`)
                    }
                }
            }
        }
    }
    return false
}1

function getIronItem(inv, p) {
    let result = {};
    for (let i = 35; i > -1; i--) {
        const item = inv.getItem(i)
        if (item) {
            if (item.typeId.includes("raw_") == true) {
                if (result["use_ultimate"]) result["use_ultimate"] = Number(result["use_ultimate"] + item.amount)
                else result["use_ultimate"] = item.amount
    
                result["use"] = 1
                result["input"] = item.typeId
                result["output"] = `${item.typeId.replace("raw_", "")}_ingot`
            }else{
                for (let v of itemsUsed) {
                    const itemM = v.split("/")[0]
                    const output = v.split("/")[1]
    
                    if (itemM === item.typeId) {
                        
                        if (result["use_ultimate"]) result["use_ultimate"] = Number(result["use_ultimate"] + item.amount)
                        else result["use_ultimate"] = item.amount
    
                        result["use"] = 1
                        result["input"] = itemM
                        result["output"] = output
                    }
                }
            }
        } 
    }
    if (result) return result
    else return false
}


mc.system.afterEvents.scriptEventReceive.subscribe(({ sourceEntity: player, message, id }) => {
    if (id !== "blayy:eve") return

     if (message === "ultimate_furnace") {
        const inv = player.getComponent("inventory").container

        let find = getIronItem(inv, player)
        for (let i = 0; i < inv.size; i++) {
            const item = inv.getItem(i)
            if (item && item.typeId === "blayy:furnace_netherstar_on" && item.getLore()[0] && item.lockMode === "inventory") {
                if (!find || !find?.output) return;

                const fuel = Number(item.getLore()[0].split(" ")[0])

                if (find.use_ultimate <= fuel) {
                    mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback false`)
                    player.runCommandAsync(`give @s ${find.output} ${find.use_ultimate}`)
                    player.runCommandAsync(`clear @s ${find.input} 0 ${find.use_ultimate}`)
                    mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback true`)
                   

                    if (fuel > 1 && fuel > find.use_ultimate) item.setLore([`${fuel - find.use_ultimate} Items fuel`])
                    else item.setLore([])
                    inv.setItem(i, item)
                } else {
                     mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback false`)
                    player.runCommandAsync(`give @s ${find.output} ${fuel}`)
                    player.runCommandAsync(`clear @s ${find.input} 0 ${fuel}`)
                     mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback true`)

                    item.setLore([])
                    inv.setItem(i, item)
                }
            }
        }
    }
    else if (message === "basic_furnace") {
        const inv = player.getComponent("inventory").container

        let find = getIronItem(inv, player)
        for (let i = 0; i < inv.size; i++) {
            const item = inv.getItem(i)
            if (item && item.typeId.startsWith("blayy:furnace_") && item.typeId.endsWith("_on") && item.getLore()[0] && item.lockMode === "inventory") {
                if (!find || !find?.output) return;

                const fuel = Number(item.getLore()[0].split(" ")[0])

                if (find.use <= fuel) {
                    mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback false`)
                    player.runCommandAsync(`give @s ${find.output} ${find.use}`)
                    player.runCommandAsync(`clear @s ${find.input} 0 ${find.use}`)
                    mc.world.getDimension("overworld").runCommandAsync(`gamerule sendcommandfeedback true`)
                   

                    if (fuel > 1 && fuel > find.use) item.setLore([`${fuel - find.use} Items fuel`])
                    else item.setLore([])
                    inv.setItem(i, item)
                } else {
                    player.runCommandAsync(`give @s ${find.output} ${fuel}`)
                    player.runCommandAsync(`clear @s ${find.input} 0 ${fuel}`)

                    item.setLore([])
                    inv.setItem(i, item)
                }
            }
        }
    }

});

mc.world.afterEvents.itemUse.subscribe(({ source: player, itemStack: item }) => {

    if (item.typeId === "blayy:furnace_netherstar_off") {
         const inv = player.getComponent("inventory").container
        const verify = getCoalItem(inv)

        if (verify && !player.isSneaking) {
            verify.remove(player)
            if (item.getLore()[0]) item.setLore([`${parseInt(item.getLore()[0].split(" ")[0]) + verify.fuel} Items fuel`])
            else item.setLore([`${verify.fuel} Items fuel`])
            player.getComponent("equippable").setEquipment("Mainhand", item)
        } else if (item.getLore()[0] && player.isSneaking && !player.hasTag("furnace_used")) {
            player.runCommandAsync(`tag @s add furnace_used`)
            player.runCommandAsync(`tag @s add ultimate_furnace`)
            let itemM = new mc.ItemStack("blayy:furnace_netherstar_on", 1)
            itemM.setLore([`${parseInt(item.getLore()[0].split(" ")[0])} Items fuel`])
            itemM.lockMode = "inventory"
            itemM.keepOnDeath = true
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        }
    } else if (item.typeId === "blayy:furnace_netherstar_on") {
        const inv = player.getComponent("inventory").container
        const verify = getCoalItem(inv)

        if (item.getLore()[0] && player.isSneaking && !player.hasTag("furnace_used") && item.lockMode != "inventory") {
            player.runCommandAsync(`tag @s add furnace_used`)
            player.runCommandAsync(`tag @s add ultimate_furnace`)


            let itemM = player.getComponent("equippable").getEquipment("Mainhand")
            itemM.setLore([`${parseInt(item.getLore()[0].split(" ")[0])} Items fuel`])
            itemM.lockMode = "inventory"
            itemM.keepOnDeath = true
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        } else if (item.getLore()[0] && player.isSneaking && item.lockMode === "inventory") {
            player.runCommandAsync(`tag @s remove furnace_used`)
            player.runCommandAsync(`tag @s remove ultimate_furnace`)


            let itemM = new mc.ItemStack("blayy:furnace_netherstar_off", 1)
            itemM.setLore([`${parseInt(item.getLore()[0].split(" ")[0])} Items fuel`])
            itemM.lockMode = "none"
            itemM.keepOnDeath = false
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        } else if (!item.getLore()[0] && player.isSneaking && item.lockMode === "inventory") {
            player.runCommandAsync(`tag @s remove furnace_used`)
            player.runCommandAsync(`tag @s remove ultimate_furnace`)


            let itemM = new mc.ItemStack("blayy:furnace_netherstar_off", 1)
            itemM.lockMode = "none"
            itemM.keepOnDeath = false
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        }
    } else if (item.typeId.startsWith("blayy:furnace_") && item.typeId.endsWith("_off")) {
        const inv = player.getComponent("inventory").container
        const verify = getCoalItem(inv)
        const arg = item.typeId.split("_")

        if (verify && !player.isSneaking) {
            verify.remove(player)
            if (item.getLore()[0]) item.setLore([`${parseInt(item.getLore()[0].split(" ")[0]) + verify.fuel} Items fuel`])
            else item.setLore([`${verify.fuel} Items fuel`])
            player.getComponent("equippable").setEquipment("Mainhand", item)
        } else if (item.getLore()[0] && player.isSneaking && !player.hasTag("furnace_used")) {
            player.runCommandAsync(`tag @s add furnace_used`)
            player.runCommandAsync(`tag @s add ${arg[1]}_furnace`)

            let itemM = new mc.ItemStack(item.typeId.replace(/off/ig, "on"), 1)
            itemM.setLore([`${parseInt(item.getLore()[0].split(" ")[0])} Items fuel`])
            itemM.lockMode = "inventory"
            itemM.keepOnDeath = true
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        }
    } else if (item.typeId.startsWith("blayy:furnace_") && item.typeId.endsWith("_on")) {
        const inv = player.getComponent("inventory").container
        const verify = getCoalItem(inv)
        const arg = item.typeId.split("_")

        if (item.getLore()[0] && player.isSneaking && !player.hasTag("furnace_used") && item.lockMode != "inventory") {
            player.runCommandAsync(`tag @s add furnace_used`)
            player.runCommandAsync(`tag @s add ${arg[1]}_furnace`)
            let itemM = player.getComponent("equippable").getEquipment("Mainhand")
            itemM.setLore([`${parseInt(item.getLore()[0].split(" ")[0])} Items fuel`])
            itemM.lockMode = "inventory"
            itemM.keepOnDeath = true
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        } else if (item.getLore()[0] && player.isSneaking && item.lockMode === "inventory") {
            player.runCommandAsync(`tag @s remove furnace_used`)
            player.runCommandAsync(`tag @s remove ${arg[1]}_furnace`)
            let itemM = new mc.ItemStack(item.typeId.replace(/on/ig, "off"), 1)
            itemM.setLore([`${parseInt(item.getLore()[0].split(" ")[0])} Items fuel`])
            itemM.lockMode = "none"
            itemM.keepOnDeath = false
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        } else if (!item.getLore()[0] && player.isSneaking && item.lockMode === "inventory") {
            player.runCommandAsync(`tag @s remove furnace_used`)
            player.runCommandAsync(`tag @s remove ${arg[1]}_furnace`)

            let itemM = new mc.ItemStack(item.typeId.replace(/on/ig, "off"), 1)
            itemM.lockMode = "none"
            itemM.keepOnDeath = false
            player.getComponent("equippable").setEquipment("Mainhand", itemM)
        }
    } 
});
